VERSION 2.00
Begin Form VBLaunch 
   Caption         =   "VB Launch"
   Height          =   1155
   Icon            =   VBLAUNCH.FRX:0000
   KeyPreview      =   -1  'True
   Left            =   2190
   LinkMode        =   1  'Source
   MaxButton       =   0   'False
   ScaleHeight     =   435
   ScaleWidth      =   4110
   Top             =   2040
   Width           =   4260
   Begin CommonDialog cdPick 
      DefaultExt      =   "MAK"
      DialogTitle     =   "Pick a VB Makefile"
      Filename        =   "*.mak"
      FilterIndex     =   1
      Left            =   1200
      Top             =   960
   End
   Begin ComboBox cbApps 
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   8.25
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   300
      Left            =   30
      Sorted          =   -1  'True
      TabIndex        =   0
      Top             =   60
      Width           =   4035
   End
   Begin Menu mnuFile 
      Caption         =   "&File"
      Begin Menu mnuExit 
         Caption         =   "E&xit           Alt-F4"
      End
   End
   Begin Menu mnuINI 
      Caption         =   "&INI"
      Begin Menu mnuFileAdd 
         Caption         =   "&Add Entry..."
         Shortcut        =   ^A
      End
      Begin Menu mnuFileDel 
         Caption         =   "&Delete Current Entry"
         Shortcut        =   ^D
      End
      Begin Menu mnuFileDelAll 
         Caption         =   "De&lete All Entries"
      End
      Begin Menu mnuSep1 
         Caption         =   "-"
      End
      Begin Menu mnuINIUpdate 
         Caption         =   "&Update Entries to VBLaunch.ini"
         Shortcut        =   ^U
      End
      Begin Menu mnuINIPath 
         Caption         =   "&Path of VB.EXE..."
      End
   End
   Begin Menu mnuLaunch 
      Caption         =   "&Launch!"
   End
   Begin Menu mnuSpecial 
      Caption         =   "&Special"
      Begin Menu FileSpecialUninstall 
         Caption         =   "&Uninstall"
      End
   End
   Begin Menu mnuAbout 
      Caption         =   "&About"
   End
End
'VB Launch (c)1993 J. Freudenheim
'CIS ID:  72717,3475

'simple app to keep track of full paths of VB Make files
'to allow us to save our fingers and mice from traversing
'directory trees all day long when switching between
'projects!

'Note: there is very little error checking going on here
'   for instance, if VB is already running but minimized,
'   you'll get an error.
'   Also, VB should be in your path if you want the "Shell"
'   command to work.


'revision history:
' 10/6/92
'   Now writes to a private VBLAUNCH.INI file in the
'   directory the program is located in.
Dim UpdateINIFlag As Integer       'flag for CanClose

Const IDOK = 1                  ' OK button pressed
Const IDCANCEL = 2              ' Cancel button pressed
Const MB_OKCANCEL = 1
Const IDYES = 6, IDNO = 7       ' Yes No buttons
Const MB_YESNOCANCEL = 3

' Define Icons for message boxes
Const MB_ICONSTOP = 16
Const MB_ICONQUESTION = 32
Const MB_ICONEXCLAMATION = 48
Const MB_ICONINFORMATION = 64

Declare Function GetPrivateProfileString Lib "Kernel" (ByVal AppName As String, ByVal KeyName As String, ByVal Default As String, ByVal ReturnedString As String, ByVal nSize As Integer, ByVal INIFile As String) As Integer
Declare Function WritePrivateProfileString Lib "Kernel" (ByVal AppName As String, ByVal KeyName As String, ByVal NewVal As String, ByVal INIFile As String) As Integer

Dim INIFile As String
Dim VBLoc As String

Sub cbApps_DblClick ()
    RunApp
End Sub

Sub FileSpecialUninstall_Click ()
    If MsgBox("Press OK ONLY if you wish to delete VB Launch and its INI file.", MB_ICONSTOP + MB_OKCANCEL, "Delete " + App.Title) <> IDOK Then
	Exit Sub
    End If
    On Error GoTo diskerrors
    DelName$ = UCase$(App.Path + "\" + App.EXEName + ".exe")
    Kill DelName$
    DelName$ = UCase$(App.Path + "\vblaunch.ini")
    Kill DelName$
    MsgBox "Uninstall Successful; Leaving VB Launch", MB_ICONINFORMATION
    End
diskerrors:
    MsgBox "Unable to Delete " + DelName$ + Chr$(10) + "Reason: " + Error$(Err), MB_ICONSTOP, "Aborting Uninstall"
    Exit Sub
End Sub

Sub Form_Load ()
    If App.PrevInstance = True Then
	MsgBox "VB Launch is already running"
	End
    End If

    'set the name of the ini file to the path from which
    'VBLAUNCH was started.

    INIFile = App.Path + "\VBLAUNCH.INI"
    VBLoc = GetProfile("VB Location", "Path")
    NullString = Chr$(0)

    'if not found in file, then just put generic title
    If VBLoc = "bad" Then VBLoc = "VB.EXE"
    
    i = 1
    'stuff the combo box with items from WIN.INI
    Do
	NewItem = GetProfile("Make Files", "Item" & Format$(i))
	If NewItem = "bad" Then Exit Do
	cbApps.AddItem NewItem
	i = i + 1
    Loop While True
    LastUsed = GetProfile("Last Used", "Path")
    If LastUsed <> "bad" Then
	cbApps = LastUsed
    Else
	If cbApps.ListCount > 0 Then
	    cbApps = cbApps.List(0)
	End If
    End If
End Sub

Sub Form_Unload (Cancel As Integer)
    If UpdateINIFlag = True Then
	
	Msg = "Changes Have Been Made; Update INI Entries Before Closing?"
	retval = MsgBox(Msg, MB_ICONQUESTION + MB_YESNOCANCEL, "Exiting VB Launch")
	Select Case retval
	    Case IDYES
		UpdateINIItems
	    Case IDNO
		Exit Sub
	    Case IDCANCEL
		Cancel = True
	End Select
    End If
    'put the last used item into
    x = WritePrivateProfileString("Last Used", "Path", (cbApps), INIFile)
End Sub

Function GetProfile (Category As String, TestStr As String) As String
    Dim DefTPath As String
    Dim RetString As String * 255
    Dim nSize As Integer

    Def = "bad"
    nSize = 100
    retval = GetPrivateProfileString(Category, TestStr, Def, RetString, nSize, INIFile)
    If retval Then
	GetProfile = Left$(RetString, retval)
    Else
	GetProfile = "bad"
    End If
End Function

Sub mnuAbout_Click ()
    LB = Chr$(10)
    Msg = "VB Launch 1.1" & LB & "(c) 1992 J. Freudenheim"
    Msg = Msg & LB & "Add and delete names of VB Make Files."
    Msg = Msg & LB & "Press Run to start the highlighted app."
    Msg = Msg & LB & "VERY little error checking: You're on your own!"
    Msg = Msg & LB
    Msg = Msg & LB & "Compuserve 72717,3475"
    
    Msg = Msg & LB & "(FreeWare)"
    MsgBox Msg, MB_ICONINFORMATION
End Sub

Sub mnuExit_Click ()
    Unload Me
End Sub

Sub mnuFileAdd_Click ()
    'call the common dialog normally used for "File Open"
    'to get the make file of their choice
    cdPick.Filename = "*.mak"
    cdPick.Action = 1
    If cdPick.Filename <> "*.mak" Then
	cbApps.AddItem cdPick.Filename
	cbApps = cdPick.Filename
	UpdateINIFlag = True    'set flag so update will be requested at unload time
    End If
End Sub

Sub mnuFileDel_Click ()
    i% = cbApps.ListIndex
    AppToDel = cbApps
    If i% < 0 Then
	If cbApps <> "" Then    'the Last used portion is in use
	    'find the item this represents
	    For i% = 0 To cbApps.ListCount - 1
		If AppToDel = cbApps.List(i%) Then
		    Exit For
		End If
	    Next i%
	    'if we still couldn't find it then just
	    'delete it from the display
	    If AppToDel <> cbApps.List(i%) Then
		cbApps = cbApps.List(0)
		Exit Sub
	    End If
	End If
    End If
    Msg$ = "Delete " & AppToDel & " from List?"
    If MsgBox(Msg$, MB_ICONQUESTION + MB_OKCANCEL) = IDOK Then
	cbApps.RemoveItem i%
	cbApps = cbApps.List(0)
	'set flag so closing app will request user if they want to update the INI
	UpdateINIFlag = True
    End If
    
End Sub

Sub mnuFileDelAll_Click ()
    If MsgBox("Delete All MakeFile Entries from VBLaunch.ini File?", MB_ICONQUESTION + MB_OKCANCEL) <> IDOK Then
	Exit Sub
    End If

    'the following line should delete all entries according
    'to the Windows api help file, but it doesn't work, so
    'we'll do it the hard way.
    'x = WritePrivateProfileString("Make Files", ByVal "", ByVal "", INIFile)
    
    i = 0
    Do
	i = i + 1
	NewItem = GetProfile("Make Files", "Item" & Format$(i))
	If NewItem = "bad" Then Exit Do
	NewApp = "Item" & Format$(i)
	x = WritePrivateProfileString("Make Files", ByVal NewApp, Chr$(0), INIFile)
    Loop While True
    cbApps.Clear
    UpdateINIFlag = False   'no more need to update INI
End Sub

Sub mnuINIPath_Click ()
    x = InputBox$("Please type in the full path of VB.EXE", App.Title, VBLoc)
    If x <> "" Then VBLoc = x
    x = WritePrivateProfileString("VB Location", "Path", VBLoc, INIFile)
End Sub

Sub mnuINIUpdate_Click ()
    UpdateINIItems
End Sub

Sub mnuLaunch_Click ()
    RunApp
End Sub

Sub RunApp ()
    Dim LaunchApp As String
    
    LaunchApp = cbApps
    If LaunchApp = "" Then
	MsgBox "Nothing to Launch, MB_ICONEXCLAMATION"
	Exit Sub
    End If

    On Error GoTo notfound

    AppActivate "Microsoft Visual Basic"   ' Activate VB
    SendKeys "%{F}", -1
    i% = DoEvents()
    SendKeys "{O}", -1
    i% = DoEvents()
    SendKeys LaunchApp, -1
    i% = DoEvents()
    SendKeys "{ENTER}", -1
    Windowstate = 1
    Exit Sub

notfound:
    retval = Shell(VBLoc + " " + LaunchApp, 1)
    Windowstate = 1
    Exit Sub
End Sub

Sub UpdateINIItems ()
    For i = 0 To cbApps.ListCount - 1
	NewApp = "Item" & Format$(i + 1)
	x = WritePrivateProfileString("Make Files", ByVal NewApp, cbApps.List(i), INIFile)
    Next i
    
    'Now erase any unused entries from the INI file!
    Do
	i = i + 1
	NewItem = GetProfile("Make Files", "Item" & Format$(i))
	If NewItem = "bad" Then Exit Do
	NewApp = "Item" & Format$(i)
	x = WritePrivateProfileString("Make Files", ByVal NewApp, Chr$(0), INIFile)
    Loop While True
    UpdateINIFlag = False   'set flag so update not requested by app at exit
End Sub

